package eu.decideh2020.devopsframework.appdescription.controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import eu.DECIDEh2020.appManager.AppManager;
import eu.DECIDEh2020.appManager.models.AppDescription;

@RestController
public class AppDescriptionRestController {

	/*@RequestMapping("/getJenkinsEndpoint")
	public String getJenkinsEndpoint() {
		String endpoint="http://www.google.com";
		return endpoint;
	}*/
	
	@RequestMapping(value = "/createNewDECIDEApplication", method = RequestMethod.POST)
	public void initAppManager(@PathVariable String gitRef, @PathVariable String token, String pkg,  String name, String description) throws IOException {
		//String gitRef = "https://github.com/antoniofll/test-application-description.git";
		//String token = "0695cec0157699d8b77a6a490a5823812ad2aed9";
		String appDescName = "DECIDE.json";
		String repoPath= "src/main/resources/repos/" + pkg;
		
		//Creation of the repository folder
		boolean success = new File(repoPath).mkdirs();
		
		//Initialize the Git repo
		AppManager manager = AppManager.open(gitRef, token , new File(repoPath));
				
		if(success) {
			//Create Application Description file (DECIDE.json) to the new app repo 
			boolean appDescFile = new File(repoPath + "/" + appDescName).createNewFile();
		}
		
		//Retrieve Application Description
		AppDescription appDescription = manager.getAppDescription();
		
		//Set Name and description of DECIDE app
		appDescription.setName(name);
		appDescription.setDescription(description);
		
		manager.writeAndSync(appDescription, "Initialized DECIDE app name and description");
		
	}
	
	/*
	 * AUX
	 */
	public boolean copyFile(File sourceFile, File destFile) {
		

		/* verify whether file exist in source location */
		if (!sourceFile.exists()) {
			System.out.println("Source File Not Found!");
		}

		/* if file not exist then create one */
		if (!destFile.exists()) {
			try {
				destFile.createNewFile();
				
				System.out.println("Destination file doesn't exist. Creating one!");
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		FileChannel source = null;
		FileChannel destination = null;

		try {

			/**
			 * getChannel() returns unique FileChannel object associated a file
			 * output stream.
			 */
			source = new FileInputStream(sourceFile).getChannel();

			destination = new FileOutputStream(destFile).getChannel();

			if (destination != null && source != null) {
				destination.transferFrom(source, 0, source.size());
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		finally {
			if (source != null) {
				try {
					source.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (destination != null) {
				try {
					destination.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		return true;
	}
}
