package eu.decideh2020.devopsframework.architect.controller;

import java.util.Arrays;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;

//Endpoint -> /architect-service
@RestController
public class ArchitectServiceRestController {

	@Autowired
	RestTemplate restTemplate;

	String serviceURL = "http://cloudpatternscompendium.osapps.fokus.fraunhofer.de";
	
	@CrossOrigin
	@RequestMapping("/nfrs")
	public String getNFRS() throws JSONException {
		String nfrs = restTemplate.getForObject(serviceURL + "/nfrs", String.class);
		return (new JSONArray(nfrs)).toString();
	}

	@CrossOrigin
	@RequestMapping("/patterns")
	public String getPatterns() throws JSONException {
		String patterns = restTemplate.getForObject(serviceURL + "/patterns", String.class);
		return (new JSONArray(patterns)).toString();
	}

	@Bean
	public RestTemplate rest() {
		return new RestTemplate();
	}
}
