package eu.decideh2020.devopsframework.architect.domain;

import java.util.List;

import javax.validation.Valid;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;

@JsonIgnoreProperties(ignoreUnknown = true)
public class Pattern {
	
	@Valid
	private String uriref;
	
	@Valid
	private String title;
	
	@Valid
	private List<String> categories;
	
	@Valid
	private String icon;
	
	@Valid
	private String subject;
	
	@Valid
	private String description;
	
	@Valid
	private String context;
	
	@Valid
	private String solution;
	
	@Valid
	private String license;
	
	@Valid
	private Page page;
	
	@Valid
	private String relation;
	
	@Valid
	private List<String> impacts;
	
	@Valid
	@JsonProperty("positive-impacts")
	private List<String> positiveImpacts;
	
	@Valid
	@JsonProperty("negative-impacts")
	private List<String> negativeImpacts;
	
	
}
