import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { HttpModule } from '@angular/http';

import { AppRoutingModule } from './app.routing';
import { ComponentsModule } from './components/components.module';

import { AppComponent } from './app.component';

import { DashboardComponent } from './dashboard/dashboard.component';
import { UserProfileComponent } from './user-profile/user-profile.component';
import { TableListComponent } from './table-list/table-list.component';
import { TypographyComponent } from './typography/typography.component';
import { ArchitectComponent } from './architect/architect.component';
import { MapsComponent } from './maps/maps.component';
import { NotificationsComponent } from './notifications/notifications.component';
import { UpgradeComponent } from './upgrade/upgrade.component';

//Services
import { JenkinsService } from "./services/jenkins.service";
import { ArchitectService } from "./services/architect.service";
import { OptimusService } from "./services/optimus.service";
import { AppChangeService } from "./services/appchange.service";
import { AuthenticationService } from "./services/authentication.service";
import { AuthGuard } from "./guards/auth.guard";

//Login
import { LoginComponent } from './login/login.component';
import { HomeComponent } from './home/home.component';
import { OptimusComponent } from './optimus/optimus.component';

@NgModule({
  declarations: [
    AppComponent,
    LoginComponent,
    DashboardComponent,
    TypographyComponent,
    ArchitectComponent,
    OptimusComponent,
    HomeComponent,
  ],
  imports: [
    BrowserModule,
    FormsModule,
    HttpModule,
    ComponentsModule,
    RouterModule,
    AppRoutingModule
  ],
  providers: [JenkinsService, OptimusService, ArchitectService, AppChangeService, AuthenticationService, AuthGuard],
  bootstrap: [AppComponent]
})
export class AppModule { }
