import { NgModule } from '@angular/core';
import { CommonModule, } from '@angular/common';
import { BrowserModule  } from '@angular/platform-browser';
import { Routes, RouterModule } from '@angular/router';

import { DashboardComponent } from './dashboard/dashboard.component';
import { UserProfileComponent } from './user-profile/user-profile.component';
import { TableListComponent } from './table-list/table-list.component';
import { TypographyComponent } from './typography/typography.component';
import { ArchitectComponent } from './architect/architect.component';
import { MapsComponent } from './maps/maps.component';
import { NotificationsComponent } from './notifications/notifications.component';
import { UpgradeComponent } from './upgrade/upgrade.component';
import { LoginComponent } from './login/login.component';
import { HomeComponent } from './home/home.component';
import { OptimusComponent } from './optimus/optimus.component';
import { AuthGuard } from './guards/auth.guard';

const routes: Routes =[
    {
       path: '',
       children: [
        { path: 'dashboard', component: DashboardComponent, canActivateChild: [AuthGuard]},
        { path: 'architect', component: ArchitectComponent, canActivateChild: [AuthGuard]},
        { path: 'optimus', component: OptimusComponent, canActivateChild: [AuthGuard]},
        { path: 'typography',component: TypographyComponent, canActivateChild: [AuthGuard]},
       ],
        component: HomeComponent,
        canActivate: [AuthGuard]
        
    },
    { path: 'login', component: LoginComponent},
    { path: '**', redirectTo: 'dashboard', pathMatch: 'full'}

];
    

@NgModule({
  imports: [
    CommonModule,
    BrowserModule,
    RouterModule.forRoot(routes)
  ],
  exports: [
  ],
})
export class AppRoutingModule { }
