import { Component, OnInit } from '@angular/core';
import { environment } from '../../environments/environment';
import { ArchitectService } from '../services/architect.service';
import { AppChangeService } from "../services/appchange.service";
import { AuthenticationService } from "../services/authentication.service";

@Component({
  selector: 'app-architect',
  templateUrl: './architect.component.html',
  styleUrls: ['./architect.component.css']
})
    
export class ArchitectComponent implements OnInit {

  //jenkinsServer = environment.jenkinsServer;
  nfrs;
  patterns;
  //Selected DECIDE app
  selectedApp = '-';

  constructor(private architectService:ArchitectService, private appChangeService:AppChangeService, private authService: AuthenticationService) {
      this.appChangeService.selectedApp$.subscribe(
            data => {
               this.selectedApp = data;
       });
   }

  ngOnInit() {
      //Load ARCHITECT patterns
      this.architectService.getNFRs().subscribe(p=>this.nfrs = p);
      this.architectService.getPatterns().subscribe(p=>this.patterns = p);
  }

}
