import { Component, OnInit, OnChanges } from '@angular/core';
import * as Chartist from 'chartist';

import { JenkinsService } from "../services/jenkins.service";
import { User } from '../models/user.auth';

import { AppChangeService } from "../services/appchange.service";

@Component({
  selector: 'app-dashboard',
  templateUrl: './dashboard.component.html',
  styleUrls: ['./dashboard.component.css']
})
export class DashboardComponent implements OnInit, OnChanges {
  //Auth
  currentUser: User;
  users: User[] = [];
  
  jobs;
 
  selectedApp = '-';
  
  
  constructor(private jenkinsService: JenkinsService, private appChangeService:AppChangeService) {
    this.appChangeService.selectedApp$.subscribe(
            data => {
               this.selectedApp = data;
            });
     
    this.currentUser = JSON.parse(localStorage.getItem('currentUser'));
  }
  
  ngOnInit() {
      this.jenkinsService.getJobs().subscribe(p=>this.jobs = p);
  }
  
  ngOnChanges(){}

}
