import { Injectable } from '@angular/core';
import { Router, CanActivate, CanActivateChild , ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { AuthenticationService } from '../services/authentication.service';
 
@Injectable()
export class AuthGuard implements CanActivate, CanActivateChild {
 
    constructor(private router: Router,  private authService: AuthenticationService) { }
 
    canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot) {
        if (this.authService.isLoggedIn()) {
            console.log("isLoggedIN!!!!!");
            // logged in so return true
            return true;
        }
        console.log("Not Logged In");
        // not logged in so redirect to login page with the return url
        this.router.navigate(['/login'], { queryParams: { returnUrl: state.url }});
        return false;
    }
    
    canActivateChild(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean {
        console.log('checking child route access');
        if (this.authService.isLoggedIn()) {
            console.log("isLoggedIN!!!!!");
            // logged in so return true
            return true;
        }
        console.log("Not Logged In");
        // not logged in so redirect to login page with the return url
        this.router.navigate(['/login']);
        return false;
    }
}