import { Component, OnInit } from '@angular/core';
import { environment } from '../../environments/environment';
import { OptimusService } from '../services/optimus.service';
import { AppChangeService } from "../services/appchange.service";

@Component({
  selector: 'app-optimus',
  templateUrl: './optimus.component.html',
  styleUrls: ['./optimus.component.css']
})
    
export class OptimusComponent implements OnInit {

  welcomeMessage;
  
  //Selected DECIDE app
  selectedApp = '-';

  constructor(private optimusService:OptimusService, private appChangeService:AppChangeService) {
      this.appChangeService.selectedApp$.subscribe(
            data => {
               this.selectedApp = data;
       });
   }

  ngOnInit() {
      //Load OPTIMUS welcome message
      this.optimusService.getWelcomeMessage().subscribe(p=>this.welcomeMessage = p);
  }

}