import { Injectable } from '@angular/core';
import { Http, Response } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { environment } from '../../environments/environment';

//Model
import { NFR } from "../models/architect.nfr";
import { Pattern } from "../models/architect.pattern";


@Injectable()
export class ArchitectService {
  
  apiUrl = environment.gateway;
  
   constructor(private http: Http) {
   }
 
  //API CALLS
   getNFRs(): Observable<NFR[]> {
      return this.http.get(this.apiUrl + "/architect-service/nfrs")
         .map((res: Response) => res.json())
         .catch((error: any) => Observable.throw('Server error'));
   }
  
  getPatterns(): Observable<Pattern[]> {
      return this.http.get(this.apiUrl + "/architect-service/patterns")
         .map((res: Response) => res.json())
         .catch((error: any) => Observable.throw('Server error'));
   }
  
  //
}