import { Injectable } from '@angular/core';
import { Http, Headers, Response } from '@angular/http';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { User } from '../models/user.auth';

import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import 'rxjs/add/observable/throw';
 
 
@Injectable()
export class AuthenticationService {
    private authUrl = 'http://localhost:4000/hello-service';
    private headers = new Headers({'Content-Type': 'application/json'});
    private loggedIn : boolean

    constructor(private http: Http) {
      this.loggedIn = false;
    }

    isLoggedIn(): boolean{
      return this.loggedIn;
    }
 
    login(username: string, password: string){
        this.loggedIn = true;
        localStorage.setItem('currentUser', JSON.stringify({ username: username, token: password }));
        console.log("########## Log in");
     }
    
 
    getToken(): String {
      var currentUser = JSON.parse(localStorage.getItem('currentUser'));
      var token = currentUser && currentUser.token;
      return token ? token : "";
    }
 
    logout(): void {
        // clear token remove user from local storage to log user out
        localStorage.removeItem('currentUser');
        this.loggedIn = false;
    }
}