import { Injectable } from '@angular/core';
import { Http, Response } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { JenkinsJob } from "../models/jenkins.job";
import { environment } from '../../environments/environment';

@Injectable()
export class JenkinsService {
  
  apiUrl = environment.apiJenkins;
  
   constructor(private http: Http) {
   }
 
 //API CALLS
  pingService(): Observable<String> {
      return this.http.get(this.apiUrl + "/")
         .map((res: Response) => res.json())
         .catch((error: any) => Observable.throw(error.json().error || 'Server error'));
   }
  
   getJobs(): Observable<JenkinsJob[]> {
      return this.http.get(this.apiUrl + "/jobs")
         .map((res: Response) => res.json())
         .catch((error: any) => Observable.throw(error.json().error || 'Server error'));
   }
  
  //
}