import { Injectable } from '@angular/core';
import { Http, Response } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { environment } from '../../environments/environment';

//Model
import { Welcome } from "../models/optimus.welcome";


@Injectable()
export class OptimusService {
  
  apiUrl = environment.gateway;
  
   constructor(private http: Http) {
   }
 
  //API CALLS
   getWelcomeMessage(): Observable<Welcome> {
      return this.http.get(this.apiUrl + "/optimus/")
         .map((res: Response) => res.json())
         .catch((error: any) => Observable.throw('Server error'));
   }
  
  //
}