package eu.decideh2020.devopsframework.jenkins.controller;

import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.offbytwo.jenkins.JenkinsServer;
import com.offbytwo.jenkins.model.Job;

import eu.decideh2020.devopsframework.jenkins.domain.JenkinsJob;

@RestController
public class JenkinsRestController {
	
	static JenkinsServer jenkins;
	
	//@Autowired
	//AppDescriptionServiceClient appDescriptionServiceClient;
	
	JenkinsRestController(){
		initJenkinsService();
	}
	
	@CrossOrigin
	@RequestMapping("/jobs")
	public ResponseEntity<Object> test() throws IOException {
		ArrayList<JenkinsJob> jobs = new ArrayList<>();
		for(String s : jenkins.getJobs().keySet()) {
			Job job = jenkins.getJobs().get(s);
			String state = String.valueOf(job.details().getLastBuild().details().getResult());
			String weather = String.valueOf(job.details().getLastBuild().details().getNumber());
			String name = job.details().getName();
			String description = job.details().getDescription();
			long lastSuccess = job.details().getLastSuccessfulBuild().details().getTimestamp();
			long lastFailed = job.details().getLastFailedBuild().details().getTimestamp();
			String url = job.details().getUrl();
			
			JenkinsJob jenkinsJob = new JenkinsJob(url, state, weather, name, description, lastSuccess, lastFailed);
			jobs.add(jenkinsJob);
		}	
		return new ResponseEntity<Object>(jobs, HttpStatus.OK);
	}
	
	@RequestMapping("/")
    public Map<String,Object> home() {
		Map<String,Object> model = new HashMap<String,Object>();
	    model.put("id", UUID.randomUUID().toString());
	    model.put("content", "Jenkins microservice is alive");
	    return model;
    }
	
	public static void initJenkinsService() {
		try {
			//jenkins = new JenkinsServer(new URI("http://localhost:8080"), "afll_decide", "decide2018");
			jenkins = new JenkinsServer(new URI("http://10.50.208.32:32773"), "afll_decide", "decide2018");
		}catch(Exception e) {
			e.printStackTrace();
		}

	}
}
